package RiverRaid;

import java.awt.Graphics;
import java.awt.Rectangle;

public abstract class Elementos {
    
    protected int posX;
    protected int posY;
    protected int largura;
    protected int deslocamento;
    protected Rectangle contorno;
    
    public Elementos(){
        
        this.posX = 0;
        this.posY = 0;
        this.deslocamento = 0;
        this.largura = 0;
        this.contorno = new Rectangle(this.posX, this.posY, this.largura, this.largura);
        
    }
    
    public abstract void desenhar(Graphics g);
    
    public abstract void mover();
    
}
