package RiverRaid;

import java.awt.Color;
import java.awt.Rectangle;
import java.awt.event.KeyEvent;
import java.util.ArrayList;

public class Heroi extends Personagens {

    public Tiro tiro;
    public int combustivel;
    public int pontos;

    public Heroi(int Y, int X, jogoPrincipal jogo) {
        super(Y, X, jogo);
        this.imagemNome = "heroi";
        this.icone = this.carregarImagem(this.imagemNome);
        this.posX = 360;
        this.posY = Y - TAMANHO;
        this.contorno = new Rectangle(this.posX, this.posY, TAMANHO, TAMANHO);
        this.deslocamento = 40;
        this.pontos = 0;
        this.combustivel = 500;

    }

    @Override
    public void mover() {


        this.pontos = 0;
        this.combustivel--;
       ((Tela)this.jogo.jPtela).periodo = 4;



        if (jogo.teclado.teclaApertada(KeyEvent.VK_RIGHT) ||jogo.teclado.teclaApertada(KeyEvent.VK_D)) {

            this.posX += this.deslocamento;

        }
        
        if (jogo.teclado.teclaApertada(KeyEvent.VK_UP) ||jogo.teclado.teclaApertada(KeyEvent.VK_W)) {

            ((Tela)this.jogo.jPtela).periodo = 2;

        }
        
        if (jogo.teclado.teclaApertada(KeyEvent.VK_DOWN) ||jogo.teclado.teclaApertada(KeyEvent.VK_S)) {

            ((Tela)this.jogo.jPtela).periodo = 6;

        }

        if (jogo.teclado.teclaApertada(KeyEvent.VK_LEFT) ||jogo.teclado.teclaApertada(KeyEvent.VK_A)) {

            this.posX -= this.deslocamento;

        }

        if (tiro == null && jogo.teclado.teclaApertada(KeyEvent.VK_SPACE)) {

            this.tiro = new Tiro(this.posX, this.posY);

        }

    }

    public ArrayList<Elementos> colisao(ArrayList<Elementos> elementos) {

        ArrayList<Elementos> mortos = new ArrayList<Elementos>();

        for (Elementos qualqer : elementos) {
            if (qualqer != null) {



                if (qualqer instanceof Inimigos) {

                    if (this.contorno.intersects(qualqer.contorno)) {

                        mortos.add(this);

                    }
                }

                if (qualqer instanceof Grama) {

                    if (this.contorno.intersects(qualqer.contorno)) {

                        mortos.add(this);

                    }
                }

                if (qualqer instanceof Combustivel) {

                    if (this.contorno.intersects(qualqer.contorno)) {

                        if (this.combustivel <= 500) {
                           
                            this.combustivel += 10;

                            

                        }
                        
                        if (this.combustivel > 500) {
                           
                            this.combustivel = 500;

                            

                        }
                        
                    }
                }
                
                if(this.combustivel <= 0){
                    
                    mortos.add(this);
                    
                }


                if (this.tiro != null) {


                    Elementos atingido = this.tiro.colisao(elementos);
                    if (atingido != null) {
                        mortos.add(atingido);
                        this.pontos = this.tiro.pontos;
                        tiro = null;
                    } else {

                        if ((this.tiro.posY + 5) <= 0) {

                            this.tiro = null;
                        }

                    }
                }

            }




        }


        return mortos;

    }
}
