package RiverRaid;

import java.awt.Color;
import java.awt.Rectangle;
import java.util.ArrayList;
import java.util.Random;

public class Inimigos extends Personagens {

    private boolean key;
    public int pontos;
    public String nome;
    public int relogio;
    public int periodo;
    public int relogio2;

    public Inimigos(int limiteY, int limiteX, jogoPrincipal jogo) {
        super(limiteY, limiteX, jogo);
        this.pontos = 0;
        this.imagemNome = nome();
        this.nome = this.imagemNome;
        this.icone = this.carregarImagem(this.imagemNome);
        this.contorno = new Rectangle(this.posX, this.posY, TAMANHO, TAMANHO);
        this.key = false;
        this.periodo = 4;
        this.relogio = 1;
        this.relogio2 = 1;
        this.deslocamento = 40;

    }

    public String nome() {
        String nome = null;

        this.aleatorio = new Random();
        int qualquer = this.aleatorio.nextInt(3);

        switch (qualquer) {//seleciona qual sera a imagem do inimigo

            case 0:
                nome = "barco";
                this.pontos = 25;
                break;

            case 1:
                nome = "helicoptero";
                this.pontos = 50;
                break;

            case 2:
                nome = "aviao";
                this.pontos = 100;
                break;

        }

        return nome;

    }

    public void colisao(ArrayList<Elementos> elementos) {

        Rectangle colisao;

        if (this.key == true) {//verifica em qual direção o inimigo esta andando
                                //para então criar um contorno que indicara a colisão 
                                //o contorno é feito tendo em vista a proxima posição do inimigo

            colisao = new Rectangle(this.posX + TAMANHO, this.posY + TAMANHO, TAMANHO, TAMANHO);

        } else {

            colisao = new Rectangle(this.posX - TAMANHO, this.posY + TAMANHO, TAMANHO, TAMANHO);

        }

        for (Elementos qualqer : elementos) {//muda a direção caso o inimigo colida com outro inimigo ou com a grama
            if (qualqer != null) {



                if (qualqer instanceof Inimigos) {

                    if (this.posX != qualqer.posX && this.posY != qualqer.posY) {
                        if (colisao.intersects(qualqer.contorno)) {

                            this.key = !this.key;

                        }
                    }
                }

                if (qualqer instanceof Grama) {

                    if (colisao.intersects(qualqer.contorno)) {

                        this.key = !this.key;

                    }
                }
            }
        }


    }

    @Override
    public void mover() {

        if (this.key == true) {

            if (relogio % periodo == 0) {

                this.posX += this.deslocamento;
                this.imagemNome = (this.nome +"2");
                this.relogio2 = 0;
            }

        } else {


            if (relogio % 2 == 0) {

                this.posX -= this.deslocamento;
                this.imagemNome = this.nome;
                this.relogio2 = 0;
            }

        }

        if (relogio % periodo== 0) {

            this.posY += this.deslocamento;
            this.relogio = 0;
        }
        this.relogio++;
        this.relogio2++;

    }
}
