package RiverRaid;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Rectangle;
import java.awt.event.KeyEvent;
import java.util.Random;
import javax.swing.ImageIcon;

public abstract class Personagens extends Elementos{

    protected Image icone;
    protected String imagemNome;
    protected  Random aleatorio;
    protected  final int TAMANHO = 40; // constante
    protected jogoPrincipal jogo;

    public Personagens(int Y, int X,jogoPrincipal jogo) {
        aleatorio = new Random();
        this.posY = Y;
        this.posX = X;
        this.jogo = jogo;
        this.contorno = new Rectangle(this.posX,this.posY,TAMANHO,TAMANHO);
        
        
    }

   


    @Override
    public abstract void mover();
    
    @Override
    
    public void desenhar(Graphics g) {

        
    
            this.icone = this.carregarImagem(this.imagemNome);
        

        this.contorno = new Rectangle(posX, posY, TAMANHO, TAMANHO);
        g.drawImage(this.icone, this.posX, this.posY, this.jogo);
    }
    

    
        protected Image carregarImagem(String imagem) {
        ImageIcon iicon = new ImageIcon(this.getClass().getResource("../imagens/" + imagem + ".png"));
        return iicon.getImage();
    }

}
    

