package RiverRaid;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.util.ArrayList;

public class Tiro extends Elementos {

    protected Color cor;
    public  int pontos;
    protected final int TAMANHO = 2; // constante

    public Tiro(int x, int y) {

        this.posX = x + 7;
        this.posY = y + 2;
        this.largura = this.TAMANHO + 5;
        this.deslocamento = 40;
        this.contorno = new Rectangle(this.posX, this.posY, this.largura, this.TAMANHO);
        this.cor = new Color(0, 255, 0);
        this.pontos = 0;

    }

    @Override
    public void mover() {

        this.posY = this.posY - this.deslocamento;

    }

    @Override
    public void desenhar(Graphics g) {


        //definindo a cor 
        g.setColor(this.cor);


        this.contorno = new Rectangle(posX, posY, TAMANHO, TAMANHO);
        g.drawRect(this.posX, this.posY, this.TAMANHO, this.TAMANHO);
    }

    public Elementos colisao(ArrayList<Elementos> elementos) {

        for (Elementos qualqer : elementos) {
            if (qualqer != null) {



                if (qualqer instanceof Inimigos) {

                    if (this.contorno.intersects(qualqer.contorno)) {

                        this.pontos  = ((Inimigos)qualqer).pontos;
                        return qualqer;

                    }
                }

                if (qualqer instanceof Combustivel) {

                    if (this.contorno.intersects(qualqer.contorno)) {

                        return qualqer;

                    }

                }
            }



        }


        return null;

    }
}
